/***************************************************************
 * Name:      wxSerieMain.h
 * Purpose:   Defines Application Frame
 * Author:    seta43 ()
 * Created:   2018-05-14
 * Copyright: seta43 ()
 * License:
 **************************************************************/

#include "main.h"
#include "define.h"
#include "port.h"


char VARI[100];
int  ContadorI=0;
char Binput[100];
char Binput2[20];
int tiempo2=10,tiempo1=5;

char VARI_OUT[100];

unsigned char portok;

int modeFinLinea=1;
int modeVelocidad;



#define ID_BUTTON1	1000
#define ID_BUTTON2	1001

#define  ID_TEXTCTRL1	1002
#define  ID_BUTTON3		1003	
#define  ID_CHECKBOX1	1004
#define  ID_BUTTON4		1005
#define  ID_CHOICE1		1006
#define  ID_CHOICE2		1007
#define  ID_CHOICE3		1008
#define  ID_TOGGLEBUTTON1	1009
#define  ID_BUTTON5		1010
#define  ID_BUTTON6		1011
#define  ID_TEXTCTRL2	1012
#define  ID_TEXTCTRL3	1013
#define  ID_TIMER1		1014


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(MiFrame,wxFrame)

    EVT_BUTTON(ID_BUTTON1, MiFrame::OnBconectarClick)
    EVT_BUTTON(ID_BUTTON2, MiFrame::OnBdesconectarClick)
    EVT_BUTTON(ID_BUTTON3, MiFrame::OnBenviarClick)
    EVT_BUTTON(ID_BUTTON4, MiFrame::OnBClearClick)
    EVT_BUTTON(ID_BUTTON5, MiFrame::OnQuit)
    EVT_BUTTON(ID_BUTTON6, MiFrame::OnAbout)   
    EVT_TIMER(ID_TIMER1, MiFrame::OnTimer1Trigger)
    EVT_CHOICE(ID_CHOICE1, MiFrame::OnBfinLineaSelect)
    EVT_CHOICE(ID_CHOICE2, MiFrame::OnBbaudSelect)
    EVT_CHOICE(ID_CHOICE3, MiFrame::OnBdeviceSelect)

END_EVENT_TABLE();

MiFrame::MiFrame(wxWindow* parent,wxWindowID id)
{

    //(*Initialize(MiFrame)
    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(556,371));
    Bconectar = new wxButton(this, ID_BUTTON1, _("ON"), wxPoint(256,304), wxSize(48,24), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Bdesconectar = new wxButton(this, ID_BUTTON2, _("OFF"), wxPoint(312,304), wxSize(48,24), 0, wxDefaultValidator, _T("ID_BUTTON2"));
    Boutput = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxPoint(16,8), wxSize(280,24), wxTE_PROCESS_ENTER, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    Benviar = new wxButton(this, ID_BUTTON3, _("Enviar"), wxPoint(312,8), wxSize(72,24), 0, wxDefaultValidator, _T("ID_BUTTON3"));
    Bdesplazz = new wxCheckBox(this, ID_CHECKBOX1, _("Desplaza."), wxPoint(16,304), wxSize(88,22), 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    Bdesplazz->SetValue(true);
    BClear = new wxButton(this, ID_BUTTON4, _("Clear"), wxPoint(16,336), wxSize(72,26), 0, wxDefaultValidator, _T("ID_BUTTON4"));
    BfinLinea = new wxChoice(this, ID_CHOICE1, wxPoint(104,336), wxSize(72,28), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE1"));
    BfinLinea->Append(_("None"));
    BfinLinea->SetSelection( BfinLinea->Append(_("LF")) );
    BfinLinea->Append(_("CR"));
    BfinLinea->Append(_("LF+RC"));
    Bbaud = new wxChoice(this, ID_CHOICE2, wxPoint(184,336), wxSize(88,28), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE2"));
    Bbaud->Append(_("300"));
    Bbaud->Append(_("600"));
    Bbaud->Append(_("1200"));
    Bbaud->Append(_("2400"));
    Bbaud->Append(_("4800"));
    Bbaud->SetSelection( Bbaud->Append(_("9600")) );
    Bbaud->Append(_("19200"));
    Bbaud->Append(_("38400"));
    Bbaud->Append(_("57600"));
    Bbaud->Append(_("115200"));
    Bdevice = new wxChoice(this, ID_CHOICE3, wxPoint(104,304), wxSize(120,24), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE3"));
  #if YesWindows
    Bdevice->SetSelection( Bdevice->Append(_("com1")) );
    Bdevice->Append(_("com2"));
    Bdevice->Append(_("com3"));
    Bdevice->Append(_("com4"));
    Bdevice->Append(_("com5"));
    Bdevice->Append(_("com6"));
 #else
    Bdevice->SetSelection( Bdevice->Append(_("/dev/ttyUSB0")) );
    Bdevice->Append(_("/dev/ttyUSB1"));
    Bdevice->Append(_("/dev/ttyUSB2"));
    Bdevice->Append(_("/dev/ttyACM0"));
    Bdevice->Append(_("/dev/ttyACM1"));
    Bdevice->Append(_("/dev/ttyACM2"));
    Bdevice->Append(_("/dev/ttyS0"));
    Bdevice->Append(_("/dev/ttyS1"));
    Bdevice->Append(_("/dev/ttyS2"));
 #endif
    wxFont BdeviceFont(9,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bdevice->SetFont(BdeviceFont);
    Bserie = new wxToggleButton(this, ID_TOGGLEBUTTON1, _("Off_Line"), wxPoint(440,8), wxSize(96,26), 0, wxDefaultValidator, _T("ID_TOGGLEBUTTON1"));
    Bserie->SetForegroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_MENUTEXT));
    Bserie->SetBackgroundColour(wxColour(255,255,255));
    wxFont BserieFont(10,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bserie->SetFont(BserieFont);
    Bsalir = new wxButton(this, ID_BUTTON5, _("Salir"), wxPoint(456,336), wxSize(85,24), 0, wxDefaultValidator, _T("ID_BUTTON5"));
    Bacerca = new wxButton(this, ID_BUTTON6, _("Acerca"), wxPoint(392,336), wxSize(56,24), 0, wxDefaultValidator, _T("ID_BUTTON6"));
    BtestInput = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxPoint(16,40), wxSize(520,248), wxTE_NO_VSCROLL|wxTE_MULTILINE|wxTE_READONLY|wxVSCROLL|wxHSCROLL, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    Bconsola = new wxTextCtrl(this, ID_TEXTCTRL3, _("--"), wxPoint(376,304), wxSize(160,24), 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    wxFont BconsolaFont(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Bconsola->SetFont(BconsolaFont);
    Timer1.SetOwner(this, ID_TIMER1);
    Timer1.Start(50, false);	
	
}

void MiFrame::OnBconectarClick(wxCommandEvent& event)
{
   wxString msg,baud;
#if DEBUG
    if(DEBUG) printf("Init\n");
#endif
#if YesWindows
    if(hSerial)CloseRs232();
#else
    if(fdrs232)CloseRs232();
#endif

    msg=Bdevice->GetStringSelection();
    strcpy( VARI, (const char*)msg.mb_str(wxConvUTF8) );
    MODEMDEVICE=VARI;

    if(0!=IniRs232())
    {
        printf("NO %s\n",MODEMDEVICE);
        msg.Printf(wxT("No existe puerto"));
        wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
        msg.Printf(wxT("No port"));
        Bconsola->SetValue(msg);
        portok=0;
        Bserie->SetBackgroundColour(wxColour(255,255,255));
		Bserie->SetLabel(_("Off_Line"));
    }
    else
    {
        baud=Bbaud->GetStringSelection();
        Bconsola->SetValue(msg+_(" :")+baud+_(" ,8,N,1"));
		printf("SI %s\n",MODEMDEVICE);
        portok=1;
        Bserie->SetBackgroundColour(wxColour(255,0,0));
		Bserie->SetLabel(_("On_Line"));
    }
}

void MiFrame::OnBsalirClick(wxCommandEvent& event)
{
#if YesWindows
    if(hSerial)CloseRs232();
#else
    if(fdrs232)CloseRs232();
#endif
    Close();
}

void MiFrame::OnBacercaClick(wxCommandEvent& event)
{
    wxString msg;
        msg.Printf(wxT("Terminal Serie\nxsetaseta@gmail.com\n%s"),    wxVERSION_STRING);
        wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
}

void MiFrame::OnBdeviceSelect(wxCommandEvent& event)
{
}

void MiFrame::OnBClearClick(wxCommandEvent& event)
{
    BtestInput->SetValue(wxT(""));
}

void MiFrame::OnBfinLineaSelect(wxCommandEvent& event)
{
   modeFinLinea = BfinLinea->GetSelection();
   printf("modeFinLinea=%d\n",modeFinLinea);
}

void MiFrame::OnBbaudSelect(wxCommandEvent& event)
{
  modeVelocidad = Bbaud->GetSelection();
#if YesWindows
    switch(modeVelocidad)
    {
        case 0:
            MiBAUDIOS=CBR_300;
        break;
        case 1:
            MiBAUDIOS=CBR_600;
        break;
        case 2:
            MiBAUDIOS=CBR_1200;
        break;
        case 3:
            MiBAUDIOS=CBR_2400;
        break;
        case 4:
            MiBAUDIOS=CBR_4800;
        break;
        case 5:
            MiBAUDIOS=CBR_9600;
        break;
        case 6:
            MiBAUDIOS=CBR_19200;
        break;
        case 7:
            MiBAUDIOS=CBR_38400;
        break;
        case 8:
            MiBAUDIOS=CBR_57600;
        break;
        case 9:
            MiBAUDIOS=CBR_115200;
        break;
    }
#else
  switch(modeVelocidad)
    {
        case 0:
            MiBAUDIOS=B300;
        break;
        case 1:
            MiBAUDIOS=B600;
        break;
        case 2:
            MiBAUDIOS=B1200;
        break;
        case 3:
            MiBAUDIOS=B2400;
        break;
        case 4:
            MiBAUDIOS=B4800;
        break;
        case 5:
            MiBAUDIOS=B9600;
        break;
        case 6:
            MiBAUDIOS=B19200;
        break;
        case 7:
            MiBAUDIOS=B38400;
        break;
        case 8:
            MiBAUDIOS=B57600;
        break;
        case 9:
            MiBAUDIOS=B115200;
        break;
    }
 #endif
    printf("modeVelocidad=%d __%d\n",modeVelocidad,MiBAUDIOS);
}

void MiFrame::OnBenviarClick(wxCommandEvent& event)
{
    wxString textval = Boutput->GetValue();

    switch(modeFinLinea)
    {
        case 0:
            sprintf(VARI_OUT,"%s",(const char*)textval.mb_str(wxConvUTF8));
        break;
        case 1:
            sprintf(VARI_OUT,"%s\n",(const char*)textval.mb_str(wxConvUTF8));
        break;
        case 2:
            sprintf(VARI_OUT,"%s\r",(const char*)textval.mb_str(wxConvUTF8));
        break;
        case 3:
            sprintf(VARI_OUT,"%s\n\r",(const char*)textval.mb_str(wxConvUTF8));
        break;
    }
    PrintSerial(VARI_OUT);
#if DEBUG
	 printf("E_%s",VARI_OUT);
#endif

}


void MiFrame::OnBdesconectarClick(wxCommandEvent& event)
{
   wxString msg;
#if YesWindows
    if(hSerial)CloseRs232();
#else
    if(fdrs232)CloseRs232();
#endif

    msg.Printf(wxT("Puerto cerrado"));
    Bconsola->SetValue(msg);
    Bserie->SetBackgroundColour(wxColour(255,255,255));
	Bserie->SetLabel(_("Off_Line"));
    portok=0;
}

void MiFrame::OnTimer1Trigger(wxTimerEvent& event)
{
   //  int z;
    int nbytes;
    wxString StringTmp;

    tiempo1--;
    tiempo2--;

// cada 0,5 segundos
    if(portok==1 && tiempo2<0)
    {
        tiempo2=10;

#if YesWindows
        while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
        while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
        {
            //printf("Leer %d -> %s\n",ContadorI,Binput2);
            Binput[ContadorI]=Binput2[0];
            ContadorI++;
            if (Binput2[0] == '\n')
            {
                if(ContadorI<2)ContadorI=2;
                Binput[ContadorI-2]=0;
                ContadorI=0;
#if DEBUG
				printf("Leidos->%s\n",Binput);
#endif
                sprintf(VARI,"%s\n",Binput);
                wxString StringTmp(VARI, wxConvUTF8);
                BtestInput->SetValue(BtestInput->GetValue() + StringTmp);
                if(Bdesplazz->GetValue())  BtestInput-> SetInsertionPointEnd();
            }
        }
    }

// cada 1 segundos ____________________________________________
    if(tiempo1<0)
    {
        tiempo1=20;
#if DEBUG
			printf("1S  portok=%d____",portok);
            const char* cadena = StringTmp.mb_str();
            printf("%s\n",cadena);
#endif
    }

}


void MiFrame::OnBoutputTextEnter(wxCommandEvent& event)
{
    this->OnBenviarClick(event);
}

