#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/tglbtn.h>
#include <wx/choice.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/timer.h>

#include "port.h"

class MiFrame: public wxFrame
{
public:
    MiFrame(wxWindow* parent,wxWindowID id = -1);
    

private:
	
    DECLARE_EVENT_TABLE()

    void OnQuit(wxCommandEvent& event)
		{ 
		#if YesWindows
			if(hSerial)CloseRs232();
		#else
			if(fdrs232)CloseRs232();
		#endif
			Close();
		}
		
    void OnAbout(wxCommandEvent& event)
            {
                wxString msg;
				msg.Printf(wxT("Terminal Serie\nxsetaseta@gmail.com\n%s"),    wxVERSION_STRING);
				wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
            }    

        void OnTextCtrl2Text(wxCommandEvent& event);
        void OnBconectarClick(wxCommandEvent& event);
        void OnBsalirClick(wxCommandEvent& event);
        void OnBacercaClick(wxCommandEvent& event);
        void OnBdeviceSelect(wxCommandEvent& event);
        void OnBClearClick(wxCommandEvent& event);
        void OnBfinLineaSelect(wxCommandEvent& event);
        void OnBbaudSelect(wxCommandEvent& event);
        void OnBenviarClick(wxCommandEvent& event);
        void OnBoutputText(wxCommandEvent& event);
        void OnBoutputText1(wxCommandEvent& event);
        void OnBdesconectarClick(wxCommandEvent& event);
        void OnTimer1Trigger(wxTimerEvent& event);
        void OnBserieToggle(wxCommandEvent& event);
        void OnBdesplazzClick(wxCommandEvent& event);
        void OnBoutputTextEnter(wxCommandEvent& event);
        
		wxTextCtrl* Boutput;
        wxCheckBox* Bdesplazz;
        wxButton* Bconectar;
        wxToggleButton* Bserie;
        wxChoice* Bdevice;
        wxButton* Bdesconectar;
        wxChoice* Bbaud;
        wxTextCtrl* Bconsola;
        wxTextCtrl* BtestInput;
        wxButton* Bacerca;
        wxButton* BClear;
        wxButton* Benviar;
        wxButton* Bsalir;
        wxChoice* BfinLinea;
        wxTimer Timer1;
};

class MiAplicacion : public wxApp
{
public:
    virtual bool OnInit();
};


bool MiAplicacion::OnInit()
{
	wxInitAllImageHandlers();
    MiFrame* Frame = new MiFrame(0);
    Frame->Show();
    return true;
}

